/* include/proto.h - Dclaration des diffrentes fonctions
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Outils serveur */
void putserv(const char *, ...);
void putchan(const char *);
void putlog(char *, const char *, ...);
void csntc(aNick *, const char *, ...);
void syntax_cmd(aNick *, int);
void csmode(aChan *, const char *, ...);
void cstopic(aChan *chan, const char *, ...);
void cskick(const char *, const char *, const char *, ...);
void cspart(const char *, const char *, ...);
void cswallops(const char *, ...);
void cswall(const char *, ...);
void csjoin(aChan *);
void cs_account(aNick *nick, const char *);

char *GetModes(aNick *nick);
char *GetCModes(aChan *chan);
char *nick2num(const char *);
char *make_servnum(int);
char *num2nick(const char *);
char *get_time(long ttime);
char *GetPrefix(aNick *nick);
char *GetChanPrefix(aNick *nick, aJoin *join, int);
char *GetUserOptions(anUser *user);
char *GetAccessOptions(anAccess *access);
char *parv2msg(unsigned int parc, char **parv, unsigned int base, unsigned int size);
void parv2msgn(unsigned int parc, char **parv, unsigned int base, char *buf, unsigned int size);
char *mkpass(char *, char *);
char *duration(int);
void conv_char(char *chan, char *string);
aNick *num2nickinfo(const char *);
struct Link *num2servinfo(const char *);
anUser *ParseNickOrUser(aNick *, char *);
void do_chan_suspend(aChan *, const char *, const char *, long int);
void show_suspend(aNick *, aChan *);
void do_user_suspend(anUser *, const char *, const char *, long int);
void show_ususpend(aNick *, anUser *);

int resolve(const char *host);
int is_ip(const char *);
void translate_esc(char *, char *, char *);
unsigned long int convert_duration(const char *);
void strupr(char *);
void strip_newline(char *);
void strlwr(char *buf);
int is_num(const char *num);
int match(const char *, const char *);
int ToggleFlag(int flags, int flag);
void do_killcheck();
void check_kills();
void check_bans();
void check_ignores();
void check_accounts();
void check_chans();

#ifdef HAVE_CRYPTHOST
char *hostprot(unsigned char *, unsigned char *);
#endif
int isignore(aNick *nick);
#ifdef HAVE_TRACK
struct track *istrack(anUser *user);
void del_track(anUser *nick);
#endif
void show_vote(aNick *nick);

/* Fichiers*/
int load_config(char *);
int load_users();
void write_anuser(anUser *);
void write_userlist();
void write_users();
void write_badchans();
int load_badchans();
void write_achan(aChan *);
void write_chans();
void write_chanlist();
int load_chans();
void load_welcome();
void write_welcome();
void write_badnicks();
int load_badnicks();
void write_cmds();
int load_cmds();
void write_bans(aChan *);
void load_votes();
void write_votes();
void append_file(const char *, const char *);
void File_UserDel(char *);

/* Get Infos*/
int IsBadNick(const char *);
int IsRegChan(const char *);
int IsRegNick(const char *);
char *IsAnOwner(const char *);
char *IsOwner(const char *, const char *);

char *getbanmask(const char *nick, const char *ident, const char *host, int bantype);
void show_accessn(anAccess *access, anUser *user, aNick *num);
int ChanLevelbyUserI(anUser *user, const char *chan);
int check_protect(aNick *, aNick *, const char *);
int checkflood(aNick *nick);
int chan_check(const char *, aNick *);
int getoption(char *, char **, int, int, int);
int IsValidNick(char *);
int IsValidMail(char *);
int GetCmdIndexbyName(const char *);
int GetCurCmdIndexbyName(const char *);
char *RealCmd(const char *);
int checkpass(const char *, anUser *);
aBan *is_ban(aNick *, aChan *);

anUser *getuserinfo(const char *);
struct badchans *getbadchan(const char *);
aChan *getchaninfo(const char *);
struct badnicks *getbadnick(const char *);
aJoin *getjoininfo(aNick *, const char *);
aNick *getnickbynick(const char *);
anAccess *GetAccessIbyUserI(anUser *, const char *chan);
struct Link *GetLinkIbyServ(const char *serv);

/* Add/Del infos*/
#ifdef USE_MEMOSERV
void add_memo(anUser *user, const char *, time_t, const char *, int);
void del_memo(anUser *user, unsigned int);
#endif
anUser *add_regnick(const char *, const char *, time_t, int, int, const char *, int);
void del_regnick(anUser *user);
void del_nickinfo(aNick *nick);
aNick *add_nickinfo(const char *, const char *, const char *, const char *, const char *, struct Link *, const char *, time_t);
struct badchans *add_abadchan(const char *, const char *);
void del_abadchan(const char *);
aChan *add_chan(const char *, const char *, const char *, const char *, const char *, const char *, int, int, int, const char *, const char *);
anAccess *add_access(anUser *, const char *, int, int, time_t);
void del_chan(char *);
void del_access(anUser *, aChan *);
void add_killinfo(const char *, const char *, time_t, int, int);
void del_killinfo(const char *, const char *);
void add_abadnick(const char *, int flag);
void del_abadnick(const char *);
void add_join(aNick *nick, char *, int, int, time_t, int);
void del_join(aNick *nick, char *);
void del_link(aChan *chan, const char *);
void add_ban(aChan *chan, const char *, const char *, const char *, time_t, time_t, int);
void del_ban(aChan *chan, const char *);
void add_ignore(const char *, time_t);
void del_ignore(const char *);
void parse_umode(aNick *nick, char *);
void parse_cmode(aChan *, char *, const char *, const char *);

void show_notes(aNick *nick);
