/* src/aide.c - Aide
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <ctype.h>
#include <main.h>

CVSINFO("$Id: aide.c,v 1.12 2003/04/09 17:13:11 romexzf Exp $");

/* Note: Les fonctions suivantes ont t reprises du CS5.0  IRCore.
 *       Elles ont t adapts pour ces services.
 */

extern struct cs_commands cs_cmds[];

void syntax_cmd(aNick *nick, int index)
{
	if(strlen(cs_cmds[index].syntax) < 2)
	{
		csntc(nick, "\2Erreur de syntaxe !");
		return;
	}
	csntc(nick, cs_cmds[index].syntax, "Syntaxe:", cs_cmds[index].cmd);
	csntc(nick, "Tapez \002/%s %s %s\002 pour plus d'informations.", cs.nick, RealCmd("aide"), cs_cmds[index].realcmd);
	return;
}

void aide(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	FILE *fp;
	char cmd[25], buf[450], *p, more[15], list[450] = {0};
	int m = 0, cur = 0, i, l = 0;

	if(!parc)
	{
		strcpy(cmd, "aide/SHOWCOMMANDS");
		if(!(fp = fopen(cmd, "r")))
		{
			csntc(nick, "Erreur interne, consultez un Administrateur.");
			return;
		}

		while(fgets(buf, 400, fp)) csntc(nick, "%s", buf);

		fclose(fp);
		return;
	}

	if((i = GetCmdIndexbyName(parv[1])) < 0)
	{
		csntc(nick, "\2Cette commande n'existe pas.");
		return;
	}

	strupr(parv[1]);
	snprintf(cmd, 25, "aide/%s", parv[1]);
	if(parc > 1)
	{
		strncpy(more, parv[2], 15);
		m = 1;
	}

	if(!(fp = fopen(cmd, "r")))
	{
		csntc(nick, "\2Aide non trouve, consultez un Administrateur");
		return;
	}
	if(m) csntc(nick, "   --[ \2\0032Aide sur\0033 %s >> %s\3\2 ]--", parv[1], more);
	else csntc(nick, "   --[ \2\0032Aide sur\0033 %s\3\2 ]--", parv[1]);
	csntc(nick, "Niveau: \2\003%s\002\003 %d", (cs_cmds[i].level > 1) ? (cs_cmds[i].level <5) ? "4ADMIN" : "12CHAN" : "3USER" , cs_cmds[i].level);

	while(fgets(buf, 450, fp))
	{
		p = buf;
		if(*p == '|')
		{
			if(m)
			{
				p++;
				if(!strncasecmp(p, more, strlen(more))) /* sous section trouve */
				{
					csntc(nick, "%s", p);
					cur = 1;
					continue;
				}
				if(cur) break;
			}
			else l = 1;
			if(!m) p++;
			p = strtok(p, " ");
			strcat(list, " ");
			strcat(list, p);
		}
		else if(cur || (!m && !l)) csntc(nick, "%s", buf);
	}

	if(m && !cur)
	{
		strcat(list, "\0");
		csntc(nick, "Aucune aide sur \2%s\2 pour la commande %s", more, parv[1]);
		csntc(nick, "Options disponibles:%s", (list[0] != '\0') ? list : " Aucune");
	}
	else
	{
		if(!m && list[0] != '\0') csntc(nick, "Options disponibles:%s", (list[0] != '\0') ? list : " Aucune");
		csntc(nick, "   Vous pouvez demander plus d'informations sur %s", bot.chan);
	}

	fclose(fp);
	return;
}

void translate_esc(char *buffer, char *tbuffer, char *botnick)
{
   int i = 0, j = 0, k = 0;
   while(buffer[i] != '\0')
   {
      if(buffer[i] == '\\')
      {
         switch(buffer[i+1])
         {
         case 'b':
            tbuffer[k] = '\037';
            break;
         case 'i':
            tbuffer[k] = '\026';
            break;
         case 'r':
            tbuffer[k] = ' ';
            break;
         case 'n':
            while(botnick[j] != '\0')
            {
               tbuffer[k] = botnick[j];
               k++;
               j++;
            }
            k--;
            break;
         case 'c':
            while(bot.chan[j] != '\0')
            {
               tbuffer[k] = bot.chan[j];
               k++;
               j++;
            }
            k--;
            break;
         }
         i+=2;
         k++;
         continue;
      }
      tbuffer[k] = buffer[i];
      i++;
      k++;
   }
   tbuffer[k] = '\0';
}
