/* src/chaninfo.c - Lire les informations  propos d'un salon
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: chaninfo.c,v 1.17 2003/04/17 16:20:43 romexzf Exp $");

/*
 * chaninfo
 *
 * parv[1] = #salon
 */
extern void whoison(aNick *nick, aChan *chaninfo, int parc, char **parv);

void chaninfo(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp;
	char options[300] = {0}, mask[20], *p;
	aJoin *j;

	if(((chaninfo->flag & C_MSECRET) || (chaninfo->flag & C_MPRIVATE)) /* salon +s ou +p */
		&& (!nick->user || !GetAccessIbyUserI(nick->user, chaninfo->chan))	/* non logu ou n'a pas d'accs */
		&& !IsAnAdmin(nick->user) && !(j=getjoininfo(nick, chaninfo->chan))) /* ET ni admin, ni prsent */
		{
			csntc(nick, "Vous ne pouvez voir le chaninfo de %s.", chaninfo->chan);
			return;
		}
	for(lp=chaninfo->access;lp && lp->value.a->level != 500;lp=lp->next);
	csntc(nick, "------------------[ \0032\002%s\002\0036 > Informations\003         ]------------------", parv[1]);
	csntc(nick, "\2Fondateur     :\2 %s", lp ? lp->value.a->user->nick : "Aucun");
	csntc(nick, "\2Description   :\2 %s", chaninfo->description);
	if(IsAnAdmin(nick->user) || !strchr(chaninfo->defmodes, 'k')) csntc(nick, "\2Defmodes      :\2 %s", chaninfo->defmodes);
	else
	{
		char *tmp2=NULL;
		tmp2=chaninfo->defmodes;
		strtok(tmp2, " ");
		csntc(nick, "\2Defmodes      :\2 %s", tmp2);
	}

	csntc(nick, "\2Deftopic      :\2 %s", chaninfo->deftopic);
	if(IsAnAdmin(nick->user)) csntc(nick, "\2Motd          :\002 %s", chaninfo->motd);
	if(IsAnAdmin(nick->user) && CWantUnreg(chaninfo)) csntc(nick, "\2Salon en procdure d'Unreg\2");
	csntc(nick, "\2Url du salon  :\2 %s", chaninfo->url);

	if(CLockTopic(chaninfo)) strcat(options, " locktopic");
	if(CNoOps(chaninfo)) strcat(options, " noops");
	if(CNoBans(chaninfo)) strcat(options, " nobans");
	if(CStrictOp(chaninfo)) strcat(options, " strictop");
	if(CSetWelcome(chaninfo)) strncat(options, " welcome", 300);
	if(CAutoInvite(chaninfo)) strncat(options, " autoinvite", 300);
	if(IsSuspend(chaninfo)) strncat(options, " suspendu", 300);
	strcat(options, "\0");

	csntc(nick, "\2Options       :\2%s", options[0] != '\0' ? options : " Aucunes");
	csntc(nick, "\2Banlevel      :\2 %d", chaninfo->banlevel);
	switch(chaninfo->bantype)
	{
		case 1: strcpy(mask, "*!*ident@*.host"); break;
		case 2: strcpy(mask, "*!*ident@*"); break;
		case 3: strcpy(mask, "*nick*!*@*"); break;
		case 4: strcpy(mask, "*!*@host"); break;
		default: strcpy(mask, "<aucun>");
	}

	csntc(nick, "\2Bantype       :\2 %s", mask);
	if(CSetWelcome(chaninfo)) csntc(nick, "\2Welcome       :\2 %s", chaninfo->welcome);
	if(IsSuspend(chaninfo)) csntc(nick, "\2Suspendu      :\2 %s", chaninfo->suspend->raison);
	csntc(nick, "\2Topic actuel  :\2 %s", chaninfo->topic);

	p = GetCModes(chaninfo);
	csntc(nick, "\2Modes actuels :\2 %s%s %s", (p[0] != '\0') ? "+" : "Aucun", p, \
		(p[0] != '\0' && (chaninfo->flag & C_MKEY)) ? (IsAnAdmin(nick->user) ? chaninfo->key : "****") : "");

	if(IsAnAdmin(nick->user)) whoison(nick, chaninfo, parc, parv);
	csntc(nick, "-");
	csntc(nick, "Utilisez la commande BANLIST pour voir les bans, et la commande ACCESS pour la liste des accs au salon.");
	return;
}
