/* src/chanopt.c - Paramtrage des options salons
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: chanopt.c,v 1.7 2003/04/17 00:58:27 romexzf Exp $");

/*
 * generic_chanopt
 *
 * parv[1] = #salon
 * parv[2] = option
 * parv[3] = argument
 */
void generic_chanopt(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	const char *c = parv[1], *cmd = parv[2];
	if(!strcasecmp(cmd, "setwelcome"))
	{
		if(CSetWelcome(chaninfo)) DelCSetWelcome(chaninfo);
		else SetCSetWelcome(chaninfo);
		csntc(nick, "Le message de bienvenue a t %sactive sur le chan \002%s\002.",\
		CSetWelcome(chaninfo) ? "" : "des", c);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "defmodes"))

	{
		char *mode;
		int a = 0;
		if(parc < 3)
		{
			csntc(nick, "Syntaxe: %s #salon DEFMODES <modes>", RealCmd("chanopt"));
			return;
		}

		if(parv[3][0] != '+' || strchr(parv[3],'-'))
		{
			csntc(nick, "Veuillez prciser des modes valides (Seulement des modes  mettre [+modes]).");
			return;
		}
		mode = parv[3];
		if(strchr(mode, 'o') || strchr(mode, 'b') || strchr(mode, 'v'))
		{
			csntc(nick, "Vous n'tes pas autoris  changer les Ops,Voices,Bans avec cette commande.");
			return;
		}
		if(!(nick->flag & N_OPER) && strchr(mode, 'O'))
		{
			csntc(nick, "Vous n'tes pas autoris  changer ce mode (O).");
			return;
		}
		if(strchr(mode, 'k')) a++;
		if(strchr(mode, 'l')) a++;

		snprintf(chaninfo->defmodes, 30, "%s %s %s", mode, (a && parc > 3) ? parv[4] : "", (a>1 && parc > 4) ? parv[5] : "");
		csntc(nick, "Les modes par defaut sont maintenant \2%s\2 sur le chan \2%s\2.", parv[3], c);
		csmode(chaninfo, "-%s %s", GetCModes(chaninfo), (chaninfo->flag & C_MKEY) ? chaninfo->key : "");
		csmode(chaninfo ,"%s", chaninfo->defmodes);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "welcome"))
	{
		if(parc < 3)
		{
			csntc(nick, "Syntaxe : %s #salon WELCOME <message>", RealCmd("chanopt"));
			return;
		}
		if(!strcasecmp(parv[3], "none"))
		{
			chaninfo->welcome[0] = '\0';
			DelCSetWelcome(chaninfo);
			csntc(nick, "Le welcome sur \2%s\2 est supprim.", c);
			write_achan(chaninfo);
			return;
		}
		parv2msgn(parc, parv, 3, chaninfo->welcome, 250);
		csntc(nick, "Le message de bienvenue sur \2%s\2 est maintenant : %s", c, chaninfo->welcome);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "deftopic"))
	{
		if(parc < 3)
		{
			csntc(nick, "Syntaxe : %s #salon DEFTOPIC <topic>", RealCmd("chanopt"));
			return;
		}
		if(CLockTopic(chaninfo))
		{
			csntc(nick, "Le LOCKTOPIC est actif sur %s", c);
			return;
		}
		parv2msgn(parc, parv, 3, chaninfo->deftopic, TOPICLEN);
		csntc(nick, "Le topic par dfaut sur \2%s\2 est maintenant: %s", c, chaninfo->deftopic);
		cstopic(chaninfo, "%s", chaninfo->deftopic);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "motd"))
	{
		if(parc < 3)
		{
			csntc(nick, "Syntaxe: %s #salon MOTD <motd>", RealCmd("chanopt"));
			return;
		}
		if(!strcasecmp(parv[3], "none"))
		{
			chaninfo->motd[0] = '\0';
			csntc(nick, "Le motd sur \2%s\2 est supprim.", c);
			write_achan(chaninfo);
			return;
		}
		parv2msgn(parc, parv, 3, chaninfo->motd, 250);
		csntc(nick, "Le message du jour de \2%s\2 est maintenant: %s", c, chaninfo->motd);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "description"))
	{
		if(parc < 3)
		{
			csntc(nick, "Syntaxe: %s #salon DESCRIPTION <description>", RealCmd("chanopt"));
			return;
		}
		parv2msgn(parc, parv, 3, chaninfo->description, 200);
		csntc(nick, "La description de \2%s\2 est maintenant: %s", c, chaninfo->description);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "chanurl"))
	{
		if(parc < 3)
		{
			csntc(nick, "Syntaxe : %s #salon chanurl <url>", RealCmd("chanopt"));
			return;
		}
		if(!strchr(parv[3], '.'))
		{
			csntc(nick, "%s ne ressemble pas au format d'une URL.", parv[3]);
			return;
		}
		strncpy(chaninfo->url, parv[3], 100);
		csntc(nick, "L'url de \2%s\2 est maintenant: %s", c, chaninfo->url);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "banlevel"))
	{
		int l = ChanLevelbyUserI(nick->user, c), n;
		if(parc < 3)
		{
			csntc(nick, "Syntaxe : %s #salon BANLEVEL <niveau>", RealCmd("chanopt"));
			return;
		}
		if(!is_num(parv[3]))
		{
			csntc(nick, "Le niveau doit tre un nombre.");
			return;
		}
		n = atoi(parv[3]);
		if((n > l || chaninfo->banlevel > l) && nick->user->level < 2)
		{
			csntc(nick, "Vous ne pouvez pas changer le banlevel s'il est  un niveau suprieur au votre, ou  un niveau suprieur.");
			return;
		}
		chaninfo->banlevel = n;
		csntc(nick, "Le banlevel pour \2%s\2 est maintenant: %d", c, chaninfo->banlevel);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "bantype"))
	{
		int t;
		char mask[20];
		if(parc < 3)
		{
			csntc(nick, "Syntaxe: %s #salon BANTYPE <n du type>", RealCmd("chanopt"));
			return;
		}
		if(!is_num(parv[3]))
		{
			csntc(nick, "Le type de ban doit tre dfini en prcisant un nombre.");
			return;
		}
		t = atoi(parv[3]);
		if(t > 4 || t < 1)
		{
			csntc(nick, "Il n'y a que 4 types diffrents de bans:");
			csntc(nick, " \0021.\2 Ban sur *!*ident@*.host");
			csntc(nick, " \0022.\2 Ban sur *!*ident@*");
			csntc(nick, " \0023.\2 Ban sur *nick*!*@*");
			csntc(nick, " \0024.\2 ban sur *!*@host");
			return;
		}
		chaninfo->bantype = t;
		switch(t)
		{
			case 1: strcpy(mask, "*!*ident@*.host"); break;
			case 2: strcpy(mask, "*!*ident@*"); break;
			case 3: strcpy(mask, "*nick*!*@*"); break;
			case 4: strcpy(mask, "*!*@host"); break;
			default: strcpy(mask, "<invalide>");
		}
		csntc(nick, "Le type de ban est maintenant sur \2%s\2. (%d)", mask, t);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "strictop"))
	{
		chaninfo->flag = ToggleFlag(chaninfo->flag, C_STRICTOP);
		csntc(nick, "Le STRICTOP a t %sactiv sur %s.", CStrictOp(chaninfo) ? "" : "des", c);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "locktopic"))
	{
		chaninfo->flag = ToggleFlag(chaninfo->flag, C_LOCKTOPIC);
		csntc(nick, "Le LOCKTOPIC a t %sactiv sur %s.", CLockTopic(chaninfo) ? "" : "des", c);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "nobans"))
	{
		chaninfo->flag = ToggleFlag(chaninfo->flag, C_NOBANS);
		csntc(nick, "Le NOBANS a t %sactiv sur %s.", CNoBans(chaninfo) ? "" : "des", c);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "noops"))
	{
		chaninfo->flag = ToggleFlag(chaninfo->flag, C_NOOPS);
		csntc(nick, "Le NOOPS a t %sactiv sur %s.", CNoOps(chaninfo) ? "" : "des", c);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(cmd, "autoinvite"))
	{
		chaninfo->flag = ToggleFlag(chaninfo->flag, C_AUTOINVITE);
		csntc(nick, "L'AUTOINVITE a t %sactiv sur %s.", CAutoInvite(chaninfo) ? "" : "des", c);
		write_achan(chaninfo);
		return;
	}
	csntc(nick, "%s n'est pas une option de chanopt valide.", cmd);
	return;
}

void locktopic(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "locktopic";
	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void strictop(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "strictop";
	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void nobans(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "nobans";
	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void noops(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "noops";
	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void activwelcome(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "setwelcome";
	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void deftopic(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i = 2;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "deftopic";
	for(;i <= parc;i++) pparv[i+1] = parv[i];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void defmodes(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i = 2;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "defmodes";
	for(;i <= parc;i++) pparv[i+1] = parv[i];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void description(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i = 2;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "description";
	for(;i <= parc;i++) pparv[i+1] = parv[i];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void csetwelcome(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i = 2;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "welcome";
	for(;i <= parc;i++) pparv[i+1] = parv[i];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void banlevel(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "banlevel";
	if(parc == 2) pparv[3] = parv[2];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void bantype(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "bantype";
	if(parc == 2) pparv[3] = parv[2];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void define_motd(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i = 2;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "motd";
	for(;i <= parc;i++) pparv[i+1] = parv[i];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void chanurl(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "chanurl";
	pparv[3] = parv[2];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}
