/* src/del_info.c - Suppression d'informations en mmoire
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "main.h"

CVSINFO("$Id: del_info.c,v 1.20 2003/05/03 21:20:39 romexzf Exp $");

extern struct badchans *badchead;
extern aKill *killhead;
extern struct badnicks *badnhead;
extern struct ignore *ignorehead;

void del_nickinfo(aNick *nick)
{
	aJoin *chan, *chanp = NULL;
	aChan *c;
	aLink *lp;
	int needwrite = 0;
	const time_t current = time(NULL);

	if(nick->user)	/* save du lastlogin) */
	{
		int size = (strlen(nick->nick) + strlen(nick->ident) + strlen(nick->host) + 3);

		if(nick->user->lastlogin) free(nick->user->lastlogin);
		nick->user->lastlogin = malloc(size);
		snprintf(nick->user->lastlogin, size, "%s!%s@%s", nick->nick, nick->ident, nick->host);

		nick->user->n = NULL;
		needwrite = 1;
	}

	chan = nick->joinhead;
	while(chan)
	{
		chanp = chan;
		if((c = getchaninfo(chan->channel)))
		{
			for(lp=c->access;lp && (nick->user && lp->value.a->user != nick->user);lp=lp->next);
			if(lp)
			{
				lp->value.a->lastseen = current;
				needwrite = 1;/* on ne write pas  chaque fois*/
			}
			del_link(c, nick->nick);
		}
		chan = chan->next;
		free(chanp);
	}
	if(needwrite && nick->user) write_anuser(nick->user);

	if(nick == nickhead)
	{
		if(!nick->next) nickhead = NULL; /*sinon plantage, hein cesar:p*/
		else
		{
			nickhead = nick->next;
			nickhead->last = NULL;
		}
	}
	else
	{
		nick->last->next = nick->next;/*on change les positions en 'sautant' l'element a del*/
		nick->next->last = nick->last;
	}

	free(nick);
	nick = NULL;
}

#ifdef USE_MEMOSERV
void del_memo(anUser *user, unsigned int position)
{
	aMemo *current, *previous = NULL;
	unsigned int i = 1;

	current=user->memohead;
	while(current)
	{
		if(i==position) break;
		else
		{
			previous = current;
			current = current->next;
		}
		i++;
	}
	if(current)
	{
		if(current == user->memohead) user->memohead = user->memohead->next;
		else previous->next = current->next;
		free(current);
		current = NULL;
	}
	return;
}
#endif

void del_abadchan(const char *chaine)
{
   struct badchans *current, *previous = NULL;

   current = badchead;
   while(current)
   {
	   if(!strcasecmp(chaine, current->chaine)) break;
	   else
	   {
		   previous = current;
		   current = current->next;
	   }
   }

   if(current)
   {
      if(current == badchead) badchead = badchead->next;
      else previous->next = current->next;
      free(current);
      current = NULL;
   }
}

void del_chan(char *chan)
{
	aChan *current, *previous = NULL;
	aBan *ban, *bt;
	aLink *lp, *lpp;
	char thechan[200], fichier[230];

	conv_char(chan, thechan);
	strlwr(thechan);
	snprintf(fichier, 230, "database/chans/%s", thechan);
	remove(fichier);
	snprintf(fichier, 230, "database/bans/%s", thechan);
	remove(fichier);
	/* Suppression de tous les accs du salon
	 (c chiant a demande d'aller voir tous les users :(
	 >> plus maintenant grace aux links (voir plus bas). On doit
	 cependant pour le moment supprimer tous les waitaccess en cherchant
	 tous les usernames vu qu'on a pas encore mis de lien entre chan et les
	 waitaccess
	 >> plus maintenant grce au flag WAIT_ACCESS*/

	current = chanhead;
	while(current)
	{
		if(!strcasecmp(chan, current->chan)) break;
		else
		{
			previous = current;
			current = current->next;
		}
	}
	if(current)
	{
		if(!previous) chanhead = current->next;
		else previous->next = current->next;
		/*nettoyage*/
		for(ban=current->banhead;ban;ban=bt)
		{
			bt=ban->next;
			free(ban);
		}
		/*nettoyage des access (grace au link=conomie de boucles*/
		for(lp=current->access;lp;lp=lpp)
		{
			lpp=lp->next;
			del_access(lp->value.a->user, current);
			write_anuser(lp->value.a->user);
		}
		free(current->access);
		current->access = NULL;
		if(current->suspend) free(current->suspend);
		free(current);
		current = NULL;
		write_chanlist();
	}
	return;
}

void del_access(anUser *user, aChan *chan)
{
	anAccess *current, *previous = NULL;
	aLink *lp = NULL, *lpp = NULL;

	current = user->accesshead;
	while(current)
	{
		if(!strcasecmp(current->chan, chan->chan)) break;
		else
		{
			previous = current;
			current = current->next;
		}
	}
	if(current)
	{
		if(!previous) user->accesshead = current->next;
		else previous->next = current->next;
	}
	lp=chan->access;
	while(lp)
	{
		if(lp->value.a->user == user) break;
		else
		{
			lpp = lp;
			lp = lp->next;
		}
	}
	if(lp)
	{
		if(!lpp) /* Ya pas de prcedent */
			chan->access = lp->next;
		else lpp->next = lp->next;
	}

	current = NULL;
	if(lp->value.a->info) free(lp->value.a->info);
	free(lp->value.a);
	lp = NULL;
	return;
}

void del_killinfo(const char *nick, const char *numeric)
{
   struct killinfo *current, *previous = NULL;

   current = killhead;
   while(current)
   {
      if(!strcmp(numeric, current->numeric) && !strcasecmp(nick, current->nick))
      {
		  if(current == killhead) killhead = killhead->next;
		  else previous->next = current->next;
		  free(current);
		  return;
      }
      else
      {
         previous = current;
         current = current->next;
      }
   }
}

void del_abadnick(const char *chaine)
{
   struct badnicks *bn, *previous = NULL;

   for(bn=badnhead;bn && strcasecmp(chaine, bn->chaine);bn=bn->next) previous=bn;

   if(bn)
   {
      if(bn == badnhead) badnhead = badnhead->next;
      else previous->next = bn->next;
      free(bn);
      bn = NULL;
      return;
   }
}

void del_join(aNick *nick, char *chan)
{
        aJoin *current, *previous = NULL;
        aChan *c = NULL;
        anAccess *access;

        if((c = getchaninfo(chan))) del_link(c, nick->nick); /* on vire le link correspondant */
        current = nick->joinhead;
        while(current) /* on cherche le salon dans nick->joinhead */
        {
			if(!strcasecmp(chan, current->channel)) break;
			else
			{
				previous = current;
				current = current->next;
			}
        }
        if(!current) return; /* pas besoin de free un truc qui pointe nulle part */

        if(!previous) nick->joinhead = current->next; /* c'etait le 1er joinhead = suivant */
        else previous->next = current->next;


        if(nick->user) /* on fout le lastseen comme il faut */
        {
			for(access=nick->user->accesshead;access && strcasecmp(access->chan, chan);access=access->next);
			if(access) access->lastseen = time(NULL);
        }

        free(current);
        current=NULL;
        return;
}

void del_link(aChan *chan, const char *nick)
{
	aLink *l, *lp = NULL;

	l=chan->members;
	while(l)
	{
		if(!strcasecmp(l->value.j->nick->nick, nick)) break; /* on a trouv le bon ! */
		lp = l;
		l = l->next;
	}

	if(!l) return;
	if(!lp) chan->members = l->next;
	else lp->next = l->next;

	free(l);
	l=NULL;
	return;

}


void del_ban(aChan *chan, const char *mask)
{
	aBan *b, *previous = NULL;

	for(b = chan->banhead;b && match(mask,b->mask);b=b->next) previous = b;

	if(b)
	{
		if(b == chan->banhead) chan->banhead = chan->banhead->next;
		else previous->next = b->next;
		free(b);
		b = NULL;
		return;
	}
	return;
}

void del_regnick(anUser *user)
{
   anAccess *chan, *ct;
   int writechan = 0;
#ifdef USE_MEMOSERV
   struct memos *memo, *mem;
#endif

   File_UserDel(user->nick);

   if(user == userhead)
   {
   	   if(!userhead->next) userhead=NULL;
	   else
	   {
	   	userhead = userhead->next;
	   	userhead->last=NULL;
	   }
   }
   else
   {
	   if(user->last) user->last->next = user->next;
	   if(user->next) user->next->last = user->last;
   }
   for(chan=user->accesshead;chan;chan=ct)
   {
	   ct=chan->next;
	   if(chan->level == 500)
	   {
		del_chan(chan->chan);
		writechan = 1;
	   }
	   else del_access(user, chan->c);
   }
#ifdef USE_MEMOSERV
   for(memo=user->memohead;memo;memo=mem)
   {
	   mem=memo->next;
	   free(memo);
   }
#endif
	if(user->suspend) free(user->suspend);
   free(user);
   user = NULL;
   write_userlist();
   if(writechan) write_chanlist();
}

void del_ignore(const char *host)
{
   struct ignore *i, *previous = NULL;

   for(i = ignorehead;i && strcmp(host,i->host);i=i->next) previous=i;

   if(!i) return;
   else
   {
      if(i == ignorehead) ignorehead = ignorehead->next;
      else previous->next = i->next;
      free(i);
      i = NULL;
   }
}
