/* src/main.c - Fichier principal
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <unistd.h>
#include <signal.h>
#define GLOBALS_DEF
#include "main.h"
#undef GLOBALS_DEF
#ifdef TESTBOT
#include "web2cs.h"
#endif

CVSINFO("$Id: main.c,v 1.17 2003/04/28 22:35:21 romexzf Exp $");

extern void register_user(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void hello_world(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void drop_user(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void showcommands(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void uptime(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void ns_login(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void ctcp_ping(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void ctcp_version(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void die(aNick *nick, aChan *chaninfo, int parc, char **parv);
#ifdef USE_MEMOSERV
extern void memos(aNick *nick, aChan *chaninfo, int parc, char **parv);
#endif
extern void inviteme(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void show_admins(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void aide(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void register_chan(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void unreg_chan(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void list_badchans(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void show_access(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void do_admin(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void del_admin(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void admin_level(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void set_welcome(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void welcome_privmsg(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void list_badnicks(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void cs_whois(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void add_user(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void del_user(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void op(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void deop(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void admin_user(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void kick(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void kickban(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void verify(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void chaninfo(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void admin_chan(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void opall(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void deopall(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void mode(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void topic(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void rdeftopic(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void rdefmodes(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void ban_cmd(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void info(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void invite(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void banlist(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void clearmodes(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void voice(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void devoice(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void clear_bans(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void unban(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void unbanme(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void admin_do(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void admin_say(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void lastseen(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void locktopic(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void strictop(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void nobans(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void noops(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void deftopic(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void defmodes(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void description(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void csetwelcome(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void myaccess(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void banlevel(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void voiceall(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void devoiceall(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void kickbanall(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void kickall(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void activwelcome(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void see_alist(aNick *nick, aChan *chaninfo, int parc, char **parv);
#ifdef USE_NICKSERV
extern void recover(aNick *nick, aChan *chaninfo, int parc, char **parv);
#endif
extern void rctopics(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void rdtopics(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void rehash_conf(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void deauth(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void restart_bot(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void cs_wall(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void show_ignores(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void reop(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void bantype(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void nickban(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void chcomname(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void chlevel(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void oubli_pass(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void disable_cmd(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void ren_chan(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void cmd_track(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void chanurl(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void write_files(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void globals_cmds(aNick *nick, aChan *chan, int parc, char **parv);
extern void whoison(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void set_protect(aNick *nick, aChan *chaninfo, int parc, char **parv);
#ifdef HAVE_VOTE
extern void do_vote(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void voter(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void vote_results(aNick *nick, aChan *c, int parc, char **parv);
#endif
void showconfig(aNick *nick, aChan *c, int parc, char **parv);
extern void set_motds(aNick *nick, aChan *c, int parc, char **parv);
extern void badmanage(aNick *nick, aChan *c, int parc, char **parv);
extern void user_set(aNick *nick, aChan *c, int parc, char **parv);

/*Welcome*/
extern void add_welcome(aNick *nick, aChan *c, int parc, char **parv);
extern void del_welcome(aNick *nick, aChan *c, int parc, char **parv);
extern void list_welcome(aNick *nick, aChan *c, int parc, char **parv);
extern void send_welcome(char *num, struct welcomeinfo *w);
extern void add_loadwelcome(int level, char *msg);

/*Moduser*/
extern void generic_moduser(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void moduser_protect(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void moduser_autovoice(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void moduser_autoop(aNick *nick, aChan *chaninfo, int parc, char **parv);

/*Chanopt*/
extern void generic_chanopt(aNick *nick, aChan *chaninfo, int parc, char **parv);
extern void define_motd(aNick *nick, aChan *chaninfo, int parc, char **parv);

struct robot bot;
#ifdef USE_WELCOMESERV
struct bots ws;
#endif
struct bots cs;
/* Les needarg sonts les nombre d'arg minimum requis */

struct cs_commands cs_cmds[] = {
 /* cmd,            function,             niveau, needarg, flag, secure, 0*/
 /* Admins*/
 {  "die",          die,                  "", 4,      0, 2, 0, 0, "" },
 {  "restart",      restart_bot,          "", 4,      0, 2, 0, 0, "" },
 {  "rehash",       rehash_conf,          "", 4,      0, 2, 0, 0, "" },
 {  "addadmin",     do_admin,             "", 4,      2, 2, 0, 0, "" },
 {  "deladmin",     del_admin,            "", 4,      1, 2, 0, 0, "" },
 {  "adminlvl",     admin_level,          "", 4,      2, 2, 0, 0, "" },
 {  "chcomname",    chcomname,            "", 4,      2, 2, 0, 0, "" },
 {  "chlevel",      chlevel,              "", 4,      2, 2, 0, 0, "" },
 {  "disable",      disable_cmd,          "", 4,      2, 2, 0, 0, "" },
#ifdef USE_WELCOMESERV
 {  "setglobwelcome",set_welcome,         "", 3,      0, 2, 0, 0, "" },
 {  "privmsg",      welcome_privmsg,      "", 3,      0, 2, 0, 0, "" },
#endif
 {  "inviteme",     inviteme,             "", 2,      0, 2, 0, 0, "" },
 {  "say",          admin_say,            "", 2,      2, 3, 0, 0, "" },
 {  "write",        write_files,          "", 2,      0, 2, 0, 0, "" },
 {  "cswall",       cs_wall,              "", 2,      1, 2, 0, 0, "" },
 {  "global",       globals_cmds,         "", 2,      2, 2, 0, 0, "" },
 {  "chan",         admin_chan,           "", 2,      1, 2, 0, 0, "" },
 {  "reop",         reop,                 "", 2,      0, 2, 0, 0, "" },
#ifdef HAVE_TRACK
 {  "track",         cmd_track,           "", 3,      1, 2, 0, 0, "" },
#endif
 {  "user",         admin_user,           "", 2,      2, 2, 0, 0, "" },
 {  "rdtopics",     rdtopics,             "", 2,      0, 2, 0, 0, "" },
 {  "rctopics",     rctopics,             "", 2,      0, 2, 0, 0, "" },
 {  "whoison",      whoison,              "", 2,      0, 3, 0, 0, "" },
#ifdef HAVE_VOTE
 {  "vote",         do_vote,              "", 3,      0, 2, 0, 0, "" },
#endif
 /* Users (check with chan access)*/
 {  "unreg",        unreg_chan,           "", 500,    1, 1, 0, 0, "" },
 {  "renchan",      ren_chan,             "", 500,    2, 1, 0, 0, "" },
 {  "adduser",      add_user,             "", 450,    3, 1, 0, 0, "" },
 {  "deluser",      del_user,             "", 450,    2, 1, 0, 0, "" },
 {  "kickbanall",   kickbanall,           "", 450,    0, 1, 0, 0, "" },
 {  "kickall",      kickall,              "", 400,    0, 1, 0, 0, "" },
 {  "opall",        opall,                "", 400,    1, 1, 0, 0, "" },
 {  "deopall",      deopall,              "", 400,    1, 1, 0, 0, "" },
 {  "clearmodes",   clearmodes,           "", 400,    0, 1, 0, 0, "" },
 {  "voiceall",     voiceall,             "", 300,    1, 1, 0, 0, "" },
 {  "devoiceall",   devoiceall,           "", 300,    1, 1, 0, 0, "" },
 {  "ban",          ban_cmd,              "", 100,    2, 1, 0, 0, "" },
 {  "nickban",      nickban,              "", 300,    2, 1, 0, 0, "" },
 {  "unban",        unban,                "", 300,    2, 1, 0, 0, "" },
 {  "kickban",      kickban,              "", 300,    2, 1, 0, 0, "" },
 {  "rdefmodes",    rdefmodes,            "", 300,    1, 1, 0, 0, "" },
 {  "rdeftopic",    rdeftopic,            "", 300,    1, 1, 0, 0, "" },
 {  "clearbans",    clear_bans,           "", 300,    0, 1, 0, 0, "" },
 {  "info",         info,                 "", 100,    0, 1, 0, 0, "" },
 {  "invite",       invite,               "", 100,    0, 1, 0, 0, "" },
 {  "op",           op,                   "", 100,    1, 1, 0, 0, "" },
 {  "deop",         deop,                 "", 100,    1, 1, 0, 0, "" },
 {  "kick",         kick,                 "", 100,    2, 1, 0, 0, "" },
 {  "mode",         mode,                 "", 100,    2, 1, 0, 0, "" },
 {  "topic",        topic,                "", 100,    2, 1, 0, 0, "" },
 {  "do",           admin_do,             "", 100,    2, 1, 0, 0, "" },
 {  "devoice",      devoice,              "", 50,     1, 1, 0, 0, "" },
 {  "voice",        voice,                "", 50,     1, 1, 0, 0, "" },
 {  "alist",        see_alist,            "", 1,      1, 1, 0, 0, "" },
 {  "unbanme",      unbanme,              "", 1,      1, 1, 0, 0, "" },
 /* Users (check with nick access)*/
 {  "listbadchans", list_badchans,        "", 1,      0, 0, 0, 0, "" },
 {  "myaccess",     myaccess,             "", 1,      0, 0, 0, 0, "" },
 {  "drop",         drop_user,            "", 1,      1, 0, 2, 0, "" },
 {  "listbadnicks", list_badnicks,        "", 1,      0, 0, 0, 0, "" },
#ifdef HAVE_VOTE
 {  "voter",        voter,                "", 1,      0, 0, 2, 0, "" },
 {  "results",      vote_results,         "", 1,      0, 0, 0, 0, "" },
#endif
#ifdef USE_MEMOSERV
 {  "memos",        memos,                "", 1,      2, 0, 1, 0, "" },
#endif
 {  "verify",       verify,               "", 1,      1, 0, 0, 0, "" },
 {  "hello",        hello_world,          "", 0,      3, 0, 1, 0, "" },
 {  "register",     register_user,        "", 0,      2, 0, 1, 0, "" },
 {  "login",        ns_login,             "", 0,      2, 0, 1, 0, "" },
#ifdef USE_NICKSERV
 {  "recover",      recover,              "", 0,      2, 0, 1, 0, "" },
#endif
 {  "deauth",       deauth,               "", 0,      0, 4, 0, 0, "" },
 {  "seen",         lastseen,             "", 0,      1, 0, 0, 0, "" },
 {  "regchan",      register_chan,        "", 0,      2, 0, 0, 0, "" },
 {  "access",       show_access,          "", 0,      2, 1, 0, 0, "" },
 {  "aide",         aide,                 "", 0,      0, 0, 0, 0, "" },
 {  "showcommands", showcommands,         "", 0,      0, 0, 0, 0, "" },
 {  "uptime",       uptime,               "", 0,      0, 0, 0, 0, "" },
 {  "banlist",      banlist,              "", 0,      1, 1, 0, 0, "" },
 {  "admin",        show_admins,          "", 0,      0, 0, 0, 0, "" },
 {  "whois",        cs_whois,             "", 0,      1, 0, 0, 0, "" },
 {  "ignorelist",   show_ignores,         "", 0,      0, 0, 0, 0, "" },
 {  "oubli",        oubli_pass,           "", 0,      2, 0, 0, 0, "" },
 {  "\001ping",     ctcp_ping,            "", 0,      0, 0, 0, 0, "" },
 {  "\001version\001", ctcp_version,      "", 0,      0, 0, 0, 0, "" },
 {  "chaninfo",     chaninfo,             "", 0,      1, 1, 0, 0, "" },
 /*moduser*/
 {  "moduser",      generic_moduser,      "", 450,    3, 1, 0, 0, "" },
 {  "autoop",       moduser_autoop,       "", 450,    1, 1, 0, 0, "" },
 {  "autovoice",    moduser_autovoice,    "", 450,     1, 1, 0, 0, "" },
 {  "protect",      moduser_protect,      "", 450,    1, 1, 0, 0, "" },
 /*chanopt*/
 {  "locktopic",    locktopic,            "", 400,    0, 1, 0, 0, "" },
 {  "strictop",     strictop,             "", 450,    0, 1, 0, 0, "" },
 {  "nobans",       nobans,               "", 450,    0, 1, 0, 0, "" },
 {  "noops",        noops,                "", 450,    0, 1, 0, 0, "" },
 {  "deftopic",     deftopic,             "", 400,    1, 1, 0, 0, "" },
 {  "defmodes",     defmodes,             "", 400,    1, 1, 0, 0, "" },
 {  "description",  description,          "", 450,    1, 1, 0, 0, "" },
 {  "welcome",      csetwelcome,          "", 450,    1, 1, 0, 0, "" },
 {  "setwelcome",   activwelcome,         "", 450,    1, 1, 0, 0, "" },
 {  "banlevel",     banlevel,             "", 400,    1, 1, 0, 0, "" },
 {  "bantype",      bantype,              "", 400,    1, 1, 0, 0, "" },
 {  "chanurl",      chanurl,              "", 450,    1, 1, 0, 0, "" },
 {  "motd",         define_motd,          "", 450,    1, 1, 0, 0, "" },
 {  "chanopt",      generic_chanopt,      "", 450,    2, 1, 0, 0, "" },
/* NOUVELLES COMMANDES ICI !*/
 {  "showconfig",   showconfig,           "", 4,      0, 2, 0, 0, "" },
#ifdef USE_WELCOMESERV
 {  "addwelcome",   add_welcome,          "", 4,      2, 2, 0, 0, "" },
 {  "delwelcome",   del_welcome,          "", 4,      1, 2, 0, 0, "" },
 {  "listwelcome",  list_welcome,         "", 4,      0, 2, 0, 0, "" },
 {  "adminmotd",    set_motds,            "", 4,      2, 2, 0, 0, "" },
#endif
 {  "abad",   badmanage,                  "", 3,      2, 2, 0, 0, "" },
 {  "set",   user_set,                    "", 1,      1, 0, 0, 0, "" },
 {  "",             NULL,                 "", 0,      0, 0, 0, 0, "" }
};

int tuptime = 0;
int premiere = 0;
int STS;
int lastresetparse = 0;
int lastresetlogs = 0;
int want_to_quit;
int lastcheckaccounts = 0;
struct userinfo *userhead = NULL;
struct nickinfo *nickhead = NULL;
struct badchans *badchead = NULL;
struct chaninfo *chanhead = NULL;
struct killinfo *killhead = NULL;
struct badnicks *badnhead = NULL;
struct ignore *ignorehead = NULL;
struct welcomeinfo *welcomehead = NULL;

extern void run_bot(int);
extern int init_bot(int, int);

/*
 *            FONCTIONS COMMANDES
 *            =-=-=-=-=-=-=-=-=-=
 *
 *    Il y a deux types de fonctions commandes.
 *    Les normales :
 *       parv[0] = pseudo du robot appel
 *       parv[1->parc] = arguments de la commandes
 *    Et les commandes salons (voir struct cs_commands) :
 *       parv[0] = nom de la commande appele
 *       parv[1] = salon appel
 *       parv[2->parv] = arguments de la commande (aprs le nom du salon)
 *    Toute sles commandes doivent respecter ce shema.
 *    Lorsqu'une commande salon est tape sur un salon, et que le premier
 *    argument n'est pas un nom de salon, le nom du salon actuel est plac
 *    automatiquement comme premier argument.
 *
 *    Pour faciliter la lecture, et au cas o il pouvait y avoir plusieurs cas
 *    (ex: cmd op, if (parc == 0) cible = nick->nick else cible = parv[1]).
 *
 *    Chaque commande emploie une entte particulire :
 *    void commande(aNick *nick, aChan *chaninfo, int parc, char **parv)
 *      aNick *nick = structure nickinfo de l'user ki a appel la fonction
 *      aChan *chaninfo = structure chaninfo du salon si la cmd est chan=1 (sinon chaninfo=NULL)
 *      int parc = nombre d'arguments *SANS COMPTER PARV[0]*. (si le dernier arg
 *                 est parv[5], alors parc = 5.)
 *      char **parv = tableau contenant les arguments (une ligne = un mot).
 *
 *    Outils utiles :
 *      parv2msgn(int parc, char **parv, int position, char buf, int size)
 *          permet de convertire une fin de tableau en un message normal.
 *          il faut spcifier le tableau et le nombre d'arguments contenu
 *          ainsi que la position  laquelle on va commencer  enregistrer
 *          le contenu dans la variable envoye en paramtre (taille max size).
 *      nick2numinfo(char nick), num2nickinfo(char num)
 *          renvoit la struct du pseudo spcifi dans l'un, et le pseudo d'une
 *          num spcifie dans l'autre.
 *     csntc(struct nickinfo *nick, char *message, ...)
 *          envoyer une notice avec le CS
 *    Pour plus d'outils, voir outils.c.
 */

void sig_handler (int crap)
{
	want_to_quit = 1;
	signal(SIGINT, &sig_handler);
	signal(SIGTERM,&sig_handler);
}

void sig_reload (int crap)
{
	signal(SIGHUP, &sig_reload);
}

void sig_alarm(int crap)
{
	time_t current = time(NULL);
	check_kills();
	check_bans();
	check_ignores();
	if((lastcheckaccounts + 7200) < current)
	{
		check_accounts();
		check_chans();
		lastcheckaccounts = current;
	}
	if((lastresetparse + WAIT_DEL_PARSES) < current)
	{
		remove(LOG_PARSES);
		lastresetparse = current;
	}
	if((lastresetlogs + WAIT_DEL_LOGS) < current)
	{
		remove(LOG_CMDS);
		remove(LOG_CHANS);
		lastresetlogs =current;
	}
	alarm(ALARMINTERVAL);
}

int main(int argc, char **argv)
{
	int sock, irc_ip, r, i = 0, restarted = 0, silent = (argc > 1 && !strcasecmp(argv[1], "-h")) ? 1 : 0;
	aNick *nick, *nt;
	aChan *chan;
	FILE *fuptime;
	char buff[150];
#ifdef N2K
	char *b;
#endif

	if((fuptime = fopen(SCODERZ_PID, "r")))
	{
		while(fgets(buff, 150, fuptime))
		{
			strip_newline(buff);
			sscanf(buff, "%d", &tuptime);
		}
		fprintf(stderr, "SCoderZ est dj lanc sur le pid %d.\n", tuptime);
		fprintf(stderr, "Si ce n'est pas le cas, supprimez le fichier '%s' et recommancez.\n", SCODERZ_PID);
		fclose(fuptime);
		exit(-1);
	}

	if (load_config(FICHIER_CONF)== (-1))
	{
		fprintf(stderr, "Erreur lors de la lecture de la configuration\n");
		exit(-1);
	}

	if((fuptime = fopen("uptime.tmp", "r")))
	{
		while(fgets(buff, 150, fuptime))
		{
			strip_newline(buff);
			sscanf(buff, "%d %d %d",&tuptime, &lastresetparse, &lastresetlogs);
		}
		fclose(fuptime);
		remove("uptime.tmp");
		restarted = 1;
	}
	r = load_cmds();
	if(!silent) printf("Chargement des commandes IRC... OK (%d)\n", r);
	r = load_chans();
	if(!silent) printf("Base de donne Salon charge (%d)\n", r);
	r = load_users();
	if(!silent) printf("Base de donne User charge (%d)\n", r);
	r = load_badchans();
	if(!silent) printf("Chargement des bads chans... OK (%d)\n", r);
#ifdef USE_WELCOMESERV
	load_welcome();
#endif
	r = load_badnicks();
	if(!silent) printf("Chargement des bads nicks... OK (%d)\n", r);
#ifdef HAVE_VOTE
	load_votes();
#endif
	STS = time(NULL);
	signal(SIGPIPE, SIG_IGN);
	signal(SIGHUP, &sig_reload);
	signal(SIGINT, &sig_handler);
	signal(SIGTERM,&sig_handler);
	signal(SIGALRM, &sig_alarm);

	r=fork();

	if (r == -1)
	{
		fprintf(stderr, "Impossible d'tablir une connexion.");
		exit(-1);
	}

	if (r > 0)
	{
		if(!restarted || silent) printf("Services CoderZ %s  Inter System\n", SPVERSION);
		if(premiere && !silent)
		{
			printf("Lorsque les services seront sur votre rseau IRC,\n");
			printf("tapez : /%s hello <username> <email> <pass>\n", cs.nick);
		}
		exit(0);
	}
#ifdef TESTBOT
	w2c_initsocket();
#endif

#ifdef N2K
    b=make_servnum(bot.num);
    strcpy(bot.servnum, b);
#ifdef USE_WELCOMESERV
    strcpy(ws.num, b);
    strcat(ws.num, "ANS");
#endif
    strcpy(cs.num, b);
	strcat(cs.num, "ACS");

#else
    strcpy(bot.servnum, make_servnum(bot.num));
	strcpy(cs.num, make_servnum(bot.num));
	strcat(cs.num, "CS");
#ifdef USE_WELCOMESERV
	strcpy(ws.num, make_servnum(bot.num));
	strcat(ws.num, "NS");
#endif
#endif

	if(!premiere)
	{
		for (; cs_cmds[i].cmd[0] != '\0'; i++)
		{
			if (!strcasecmp(cs_cmds[i].cmd,"hello")) cs_cmds[i].flag |= CMD_DISABLE;
			if(cs_cmds[i].realcmd[0] == '\0') strcpy(cs_cmds[i].realcmd, cs_cmds[i].cmd);
		}
	}

	if(!(fuptime = fopen(SCODERZ_PID, "w")) && !silent) printf("Impossible d'crire le ficier PID...\n");
	else
	{
		fprintf(fuptime, "%d\n", getpid());
		fclose(fuptime);
	}

	while (want_to_quit==0)
	{
		irc_ip = resolve(bot.ip);
		if ((irc_ip == 0) || (irc_ip == -1))
		{
			sock = -1;
		} else sock = init_bot(irc_ip, bot.port);
		bot.ipnum = irc_ip;

		if (sock<0) putlog(LOG_PARSES, "Connection choue\n");
		else run_bot(sock);

		if (want_to_quit==1) close(sock);
		else
		{
			putlog(LOG_PARSES, "Dconnect par le serveur\n");

			for(nick = nickhead;nick;nick = nt)
			{
				nt=nick->next;
				del_nickinfo(nick);
			}

			for(chan = chanhead;chan;chan = chan->next) DelCJoined(chan);
			close(sock);
			sleep(WAIT_CONNECT);
		}
	}
	putlog(LOG_PARSES, "Fermeture normale du programme\n");
	return (0);
}
