/* src/memoserv.c - Diverses commandes sur le module memoserv
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "main.h"

CVSINFO("$Id: memoserv.c,v 1.14 2003/04/28 22:35:21 romexzf Exp $");

#ifdef USE_MEMOSERV

void show_notes(aNick *nick)
{
	aMemo *memo;
	int i = 0;
	for(memo=nick->user->memohead;memo;memo=memo->next) if(!memo->read) i++;

	if(i) csntc(nick, "Vous avez reu \002%d\2 nouveau%s memo%s, pour le%s lire tapez \2/%s %s LIRE <ALL|N du memo>\2", i, (i>1)?"x":"", (i>1)?"s":"", (i>1)?"s":"", cs.nick, RealCmd("memos"));
	return;
}

void memos(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aMemo *memo,*mt;
	int i = 0, p = 0, found = 0;
	const char *cmd = parv[1];

	if(!strcasecmp(cmd, "LIRE") || !strcasecmp(cmd, "READ"))
	{
		if(parc<2)
		{
			csntc(nick, "Syntaxe : %s LIRE <ALL|N DU MEMO>", RealCmd("memos"));
			csntc(nick, "Permet de lire un/tous les memo(s)");
			return;
		}
		if(is_num(parv[2])) i = atoi(parv[2]);
		for(memo=nick->user->memohead;memo;memo=memo->next)
		{
			p++;
			if(p==i || !i)
			{
				csntc(nick, "%c#%d De %s [%s] :\002 %s", memo->read ? ' ' : '*', p, memo->de, get_time(memo->date), memo->message);
				found = memo->read = 1;
			}
		}
		if(!i && found)	csntc(nick, "Il y a \002%d\002 memo%s au total (Tapez /%s MEMOS SUPPR ALL pour les supprimer)", p, (p>1)?"s":"", cs.nick);
		else if (found)	csntc(nick, "Fin du memo n%d (Tapez /%s MEMOS SUPPR %d pour le supprimer)", i, cs.nick, i);
		else if (!i && !found) csntc(nick, "Vous n'avez aucun memo.");
		else csntc(nick, "Le memo n%d n'a pas t trouv", i);
	}
	else if(!strcasecmp(cmd, "SUPPRIMER") || !strcasecmp(cmd, "ERASE")
		|| !strcasecmp(cmd, "SUPR") || !strcasecmp(cmd, "SUPPR") || !strcasecmp(cmd, "DEL"))
	{
		if(parc<2)
		{
			csntc(nick, "Syntaxe : %s SUPPR <ALL|N DU MEMO>", RealCmd("memos"));
			csntc(nick, "Permet de supprimer un/tous les memo(s)");
			return;
		}
		if(is_num(parv[2])) i = atoi(parv[2]);
		for(memo=nick->user->memohead;memo;memo=mt)
		{
			p++;
			mt=memo->next;
			if(p==i || !i)
			{
				del_memo(nick->user,i?p:1);
				found = 1;
				if(p==i) break;
			}
		}
		if(!i && found)
			csntc(nick, "Tous les memos ont bien t supprims");
		else if (!i && !found)
			csntc(nick, "Il n'y a aucun memo");
		else if (found)
			csntc(nick, "Le memo n%d a bien t supprim", i);
		else
			csntc(nick, "Le memo n%d n'a pas t trouv", i);
		write_anuser(nick->user);
	}
	else if(!strcasecmp(cmd, "SEND") || !strcasecmp(cmd, "ENVOYER"))
	{
		anUser *user;
		aNick *who;
		char message[MEMOLEN + 1], tmp[450], *tmp2;

		if(parc < 3)
		{
			csntc(nick, "Syntaxe : %s ENVOYER/SEND <username> <message>", RealCmd("memos"));
			return;
		}
		if(!(user = getuserinfo(parv[2])))
		{
			csntc(nick, NOSUCHUSER, parv[2]);
			return;
		}
		if(!strcasecmp(user->nick, nick->user->nick))
		{
			csntc(nick, "Vous ne pouvez pas vous envoyer de memo!");
			return;
		}
		if(UNoMemo(user) && !IsAnAdmin(nick->user))
		{
			csntc(nick, "%s n'accepte pas de memo.", user->nick);
			return;
		}

		parv2msgn(parc, parv, 3, tmp, 450);
		tmp2=tmp;
		if(*tmp2 == ':') tmp2++;

		if(strlen(tmp) >= MEMOLEN)
		{
			csntc(nick, "Veuillez envoyer un memo plus court ! (%d caractres max)", MEMOLEN);
			strncpy(message, tmp, MEMOLEN);
			csntc(nick, "Tronqu a donne: \2%s\2", message);
			return;
		}
		strncpy(message, tmp2, MEMOLEN);

		if((who = user->n) && !(who->flag & N_AWAY)) csntc(who, "\2MEMO DE %s@%s :\2 %s", nick->nick, nick->user->nick, message);

		for(memo = user->memohead;memo;memo = memo->next) if(!strcasecmp(memo->de,nick->user->nick)) i++;
		if(i >= MAXMEMOS && !IsAnAdmin(nick->user))
		{
			csntc(nick, "Vous avez dj envoy suffisament de mmos  %s. (MAX: %d)", user->nick, MAXMEMOS);
			return;
		}

		add_memo(user, nick->user->nick, time(NULL), message, (who && !(who->flag & N_AWAY)) ? 1 : 0);
		csntc(nick, "Un memo a bien t envoy  %s avec le texte suivant :", user->nick);
		csntc(nick, "  \002%s\2", message);
		write_anuser(user);
	}
	else
	{
		csntc(nick, "La sous commande \002%s\2 n'existe pas.", cmd);
		syntax_cmd(nick, GetCmdIndexbyName("MEMOS"));
		return;
	}
	return;
}
#endif
