/* src/nickserv.c - Diverses commandes sur le module nickserv
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>
#include <unistd.h>
#include <stdarg.h>
#include <ctype.h>

CVSINFO("$Id: nickserv.c,v 1.54 2003/05/03 21:20:39 romexzf Exp $");

extern const int ConfFlag;
extern const char HIDDEN_HOST[];
extern const char *network;
extern const char *mailprog;
extern const int ConfFlag;
extern const int kill_interval;

#ifdef USE_WELCOMESERV
char user_motd[400];
char admin_motd[400];
#endif

#ifdef HAVE_VOTE
extern const int vote_nbprop, vote_actif;
extern const struct votes vote[];
#endif

void cswall(const char *msg, ...)
{
	aNick *n;
	char buf[512];

	va_list vl;
	va_start(vl, msg);
	vsnprintf(buf, 512, msg, vl);
	va_end(vl);

	for(n=nickhead;n;n=n->next) if(n->user && IsAnAdmin(n->user)) csntc(n, buf);
	return;
}

void hello_world(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	struct userinfo *user;
#ifdef USE_MEMOSERV
	char memo[MEMOLEN + 1];
#endif
	int flag=0;

	if(!premiere)
	{
		csntc(nick, "Hello ! L'owner des services a dj t dfini");
		return;
	}
	if(parc < 2)
	{
		csntc(nick, "La syntaxe est: /%s HELLO <login> <mail> <pass>", cs.nick);
		return;
	}
	if ((user = getuserinfo(parv[1])))
	{
		csntc(nick, "%s est dj un UserName enregistr. (Dernire visite il y a %s)", user->nick, duration(time(NULL) - user->lastseend));
		return;
	}
	if(nick->user)
	{
		csntc(nick, "Vous tes dj identifi sous l'username \002%s\2, et vous ne pouvez avoir plus d'un username.", nick->user);
		return;
	}
	if(strlen(parv[2]) > 99)
	{
		csntc(nick, "Le mail est limit  99 caractres.");
		return;
	}
	if(!IsValidMail(parv[2]))
	{
		csntc(nick, "Veuillez entrer un email correct.");
		return;
	}

	flag |= (U_NOPURGE | U_POKACCESS);

	user=add_regnick(parv[1], mkpass(parv[3], "lala"), time(NULL), 4, flag, parv[2], 0);

	flag = 0; /* reset pour access flag */
	flag |= (A_OP | A_VOICE | A_PROTECT);

#ifdef USE_MEMOSERV
	snprintf(memo, MEMOLEN, "Bienvenue sur les services CoderZ. Vous pouvez avoir la liste de leurs commandes en tapant \037/%s showcommands\037.", cs.nick);
	add_memo(user, "Services", time(NULL), memo, 0);
#endif

	csntc(nick, "Hello ! Vous tes bien reconnu comme administrateur des services CoderZ");
	csntc(nick, "Vous tes de niveau 4, qui est le plus grand niveau admin. Le niveau 0 est le niveau non enregistr, niveau 1 niveau user normal identifi, et de 2  4 admin");
	csntc(nick, "Veuillez lire README pour plus d'informations");

	chaninfo = add_chan(bot.chan, "Salon d'aide  propos des services CoderZ", "Salon d'aide  propos des services CoderZ", "+nt", "Salon d'aide  propos des services CoderZ", "Bienvenue sur le salon d'aide aux services CoderZ", 0, 100, 1, "Vous pouvez aider nos users !", network);
	add_access(user, bot.chan, 500, flag, time(NULL));
	csjoin(chaninfo);
	csmode(chaninfo, "+ont %s", cs.num);
	csntc(nick, "Le salon %s vient d'tre enregistr sous votre pseudo", bot.chan);
	putlog(LOG_CHANS, "HELLO %s par %s (%s)\n", bot.chan, nick->nick, "Salon d'aide  propos des services CoderZ");
	write_chanlist();
	write_achan(chaninfo);

	csntc(nick, "Vous avez enregistr votre username (%s).", parv[1]);
	csntc(nick, "Votre nick devient votre UserName et sera utilis pour tous vos accs aux services.");
	csntc(nick, "Pour vous identifier  TOUS les services, il suffit de taper /%s %s %s <pass>", cs.nick, RealCmd("login"), parv[1]);
	append_file(USERS_FILE,user->nick);
	write_anuser(user);
	premiere = 0;
	return;
}
#undef RAND_MAX
#define RAND_MAX 23456789

void register_user(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *user = NULL;
	char passwd[20]
#ifdef USE_MEMOSERV
, memo[MEMOLEN + 1]
#endif
, p[15];
	time_t current = time(NULL);
#ifndef ADMINREG
	aNick *nt = NULL;
	FILE *fm;
	int i = 0, j;
	char c, mail[150], dir[50];
#endif

#ifdef ADMINREG
	if(!nick->user || !IsAnAdmin(nick->user))
	{
		csntc(nick, "Le CServ est configur pour que les enregistrements d'username ne soit fait que par des Admins.");
		csntc(nick, "Consultez les pour plus d'informations");
		return;
	}
#else
	if(NRegister(nick)) /* on check a avant tout parce que a sert  rien de faire les verifs sinon*/
	{
		csntc(nick, "Vous avez dja utilis la commande register !");
		return;
	}

	if(!strcasecmp(mailprog, "nomail"))
	{
#endif
		if(parc < 3)
		{
			csntc(nick, "Veuillez spcifier un mot de passe.");
			return;
		}
		if(strlen(parv[3]) < 6 || strlen(parv[3]) > 15)
		{
			csntc(nick, "Le pass doit faire entre 6 et 15 caractres.");
			return;
		}
		strncpy(p,parv[3],15);
#ifndef ADMINREG
	}
	else
	{
		srand(time(NULL)); /* on genere un mot de passe au pif */
		for(j=0;j<=10;j++)
		{
			do i = rand()%57 + 65;
			while(i >= 91 && i <= 96);
			c = i;
			p[j] = c;
		}
		p[11] = '\0';

	}
#endif

	if(!IsValidNick(parv[1]))
	{
		csntc(nick, "%s ne peut pas tre enregistr: contient des caractres illgaux", parv[1]);
		return;
	}
	if(IsBadNick(parv[1]))
	{
		csntc(nick, "%s ne peut pas tre enregistr: pseudo illgal.", parv[1]);
		return;
	}
#ifndef ADMINREG
	if(strcasecmp(nick->nick, parv[1]) && (nt=getnickbynick(parv[1]))) /* le nick existe mais n'est pas le sien, risque d'abus*/
	{
		csntc(nick, "Ce pseudo est actuellement utilis mais ce n'est pas le votre, vous ne pouvez donc pas l'enregistrer.");
		return;
	}
#endif

	if ((user = getuserinfo(parv[1])))
	{
		csntc(nick, "%s est dj un UserName enregistr. (Dernire visite il y a %s)", user->nick, duration(current - user->lastseend));
		return;
	}
#ifndef ADMINREG
	if(nick->user)
	{
		csntc(nick, "Vous tes dj identifi sous l'username \2%s\2, et vous ne pouvez avoir plus d'un username.", nick->user);
		return;
	}
#endif

	if(strlen(parv[1]) > NICKLEN)
	{
		csntc(nick, "La longueur de l'UserName est limite  %d.", NICKLEN);
		return;
	}
	if(strlen(parv[2]) > 99)
	{
		csntc(nick, "Le mail est limit  99 charactres.");
		return;
	}
	if(!IsValidMail(parv[2]))
	{
		csntc(nick, "Veuillez entrer un email correct.");
		return;
	}
	strcpy(passwd, mkpass(p, "lala"));

	for(user=userhead;user;user=user->next)
	{
		if(!strcasecmp(user->mail, parv[2]))
		{
			csntc(nick, "Ce mail est dj utilis.");
			return;
		}
	}

#ifdef ADMINREG
	user = add_regnick(parv[1], passwd, current, 1, U_POKACCESS, parv[2], 0);
#else
	SetNRegister(nick);
	if(!strcasecmp(mailprog, "nomail")) user = add_regnick(parv[1], passwd, current, 1, U_POKACCESS, parv[2], 0); /* Pas de programme de mail, protection inactive */
    else user = add_regnick(parv[1], passwd, current, 1, (U_POKACCESS | U_FIRST), parv[2], 0);
#endif

#ifdef USE_MEMOSERV
	snprintf(memo, MEMOLEN, "Bienvenue sur les services CoderZ.  Vous pouvez avoir la liste de leur commandes en tapant \037/%s showcommands\037", cs.nick);
	add_memo(user, "Services", current, memo, 0);
#endif

#ifndef ADMINREG
	if(!strcasecmp(mailprog, "nomail"))
	{
		nick->user = user;
		nick->user->n = nick;
#ifdef HAVE_VOTE
		nick->user->vote = -1;
#endif
		cs_account(nick, nick->user->nick);

		csntc(nick, "Vous avez enregistr l'UserName %s avec le pass \002%s\2 et le mail \002%s\2.",parv[1], parv[3], parv[2]);
		csntc(nick, "\2Vous avez t identifi  TOUS les services");
		csntc(nick, "Lors de vos prochaines connexions vous pourrez vous identifier avec : \37/%s %s %s %s", cs.nick, RealCmd("login"), parv[1], parv[3]);
		csntc(nick, "Le mail (%s) que vous avez fournis peut tre utilis pour vous envoyer un pass en cas de problmes.", parv[2]);
		csntc(nick, "Vous pouvez voir la liste des commandes avec \2/%s %s\2", cs.nick, RealCmd("showcommands"));
	}
	else
	{
		snprintf(dir, 50, "database/%s.mail", user->nick);
		if(!(fm = fopen(dir, "w")))
		{
			csntc(nick, "Impossible d'envoyer le mail, votre pass est %s", p);
			return;
		}
		fprintf(fm, "Subject: %s @ %s - Enregistrement UserName %s\n\n\n", cs.nick, network, user->nick);
		fprintf(fm, "Ceci est un email automatique du robot %s\n\nVotre mot de passe est : %s\n", cs.nick, p);
		fprintf(fm, "\nVeuillez le conserver.\nPour vous identifier tapez : /%s %s %s %s\n", cs.nick, RealCmd("login"), user->nick, p);
		fprintf(fm, "Si vous voulez le changer, tapez: /%s %s pass <pass>\n\n\n%s, Services IRC CoderZ de %s\n", cs.nick, RealCmd("set"), cs.nick, network);
		fclose(fm);
		snprintf(mail, 150, "%s -f \"Services de %s\" %s < %s\n", mailprog, network, user->mail, dir);
		system(mail);
		remove(dir);

		csntc(nick, "Votre mot de passe a t envoy  \2%s\2", user->mail);
		csntc(nick, "Le compte sera supprim dans %s si vous ne vous loguez pas dessus", duration(REGISTER_TIMEOUT));

	}
#else
	csntc(nick, "Username \2%s\2 enregistr (Mail: %s Pass: %s)", user->nick, user->mail, parv[3]);
#endif
	append_file(USERS_FILE,user->nick);
	write_anuser(user);
	return;
}


/*
 * oubli_pass
 *
 * parv[1] = login
 * parv[2] = mail
 */
void oubli_pass(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	FILE *fm;
	anUser *user;
	char passwd[15], mail[150], dir[50];

	if(!strcasecmp(mailprog, "nomail"))
	{
		csntc(nick, "La commande est pour le moment desactive.");
		csntc(nick, "Si vous avez oubli votre pass, demandez  un admin (\2/%s %s\2) de le changer", cs.nick, RealCmd("admin"));
		return;
	}
	if(nick->user)
	{
		csntc(nick, "Vous tes dj identifi sur un username");
		return;
	}
	if(!(user = getuserinfo(parv[1])))
	{
		csntc(nick, NOSUCHUSER, parv[1]);
		return;
	}
	if(user->flag & U_OUBLI)
	{
		csntc(nick, "La commande OUBLI a dj t utilise pour %s.", user->nick);
		return;
	}
	if(strcasecmp(user->mail, parv[2]))
	{
		csntc(nick, "Le mail de l'account %s n'est pas %s", user->nick, parv[2]);
		return;
	}
	SetNRegister(nick); /* si il se sert de oubli, c'est qu'il a deja un pseudo ! na ! */
	user->flag |= U_OUBLI;

	if(user->nick[0] % 2) snprintf(passwd, 15, "np%02dl", rand());
	else snprintf(passwd, 15, "pr%02dh", rand());
	strcpy(user->passwd, mkpass(passwd, "lala"));

	snprintf(dir, 50, "database/%s.mail", user->nick);
	if(!(fm = fopen(dir, "w")))
	{
		csntc(nick, "Impossible d'envoyer le mail");
		return;
	}
	fprintf(fm, "Subject: %s @ %s - Mot de passe oubli\n\nCher(e) %s\n\nVotre mot de passe sur %s est maintenant : %s\n", cs.nick, network, user->nick,cs.nick, passwd);
	fprintf(fm, "\nVeuillez le conserver.\nPour vous identifier tapez : /%s %s %s %s\n", cs.nick, RealCmd("login"), user->nick, passwd);
	fprintf(fm, "Si vous voulez le changer, tapez: /%s %s pass <pass>\n\n\n%s, Services IRC CoderZ de %s\n", cs.nick, RealCmd("set"), cs.nick, network);
	fclose(fm);
	snprintf(mail, 150, "%s -f \"Services d'%s\" %s < %s\n", mailprog, network, user->mail, dir);
	system(mail);
	remove(dir);

	csntc(nick, "Le nouveau pass vient d'tre envoy par mail  %s", parv[2]);
	write_anuser(user);
	return;
}


void drop_user(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anAccess *access, *a2;

	if(!nick->user)
	{
		csntc(nick, "Accs refus. Vous devez tre identifi pour DROP votre Username.");
		return;
	}

	if(UWantDrop(nick->user))
	{
		if(!strcasecmp(parv[1], "OUI"))
		{
			csntc(nick, "Votre UserName (%s) a t supprim, ainsi que tous vos accs/mmos.", nick->user->nick);
			cs_account(nick, NULL);

			for(access=nick->user->accesshead;access;access=a2)
			{
				a2=access->next;
				if(access->level == 500)
				{
					del_chan(access->chan);
					csntc(nick, "Le salon %s a bien t dsenregistr", access->chan);
					cspart(access->chan, "Salon dsenregistr par %s -\2 Suppression de l'username de l'owner", nick->nick);
					cswallops("Le salon %s a t dsenregistr par %s -\2 Suppression de l'username de l'owner", access->chan, nick->nick);
					putlog(LOG_CHANS, "DROP %s par %s@%s (%s)\n", access->chan, nick->nick, nick->user->nick, "Suppression de l'username de l'owner");
					break;
				}
			}
			del_regnick(nick->user);
			write_userlist();
			nick->user = NULL;
		}
		else if(!strcasecmp(parv[1], "NON"))
		{
			csntc(nick, "Votre username ne sera donc pas supprim");
			DelUWantDrop(nick->user);
		}
		else
		{
			csntc(nick, "Voulez vous rellement supprimer votre username ?");
			csntc(nick, "Rponse : /%s %s oui/non", cs.nick, RealCmd("drop"));
		}
		return;
	}
	else
	{
		if (checkpass(parv[1], nick->user))
		{
			csntc(nick, "Voulez vous rellement supprimer votre username ?");
			csntc(nick, "\2ATTENTION :\2 La suppression de votre username se rsulte  supprimer tous vos memos, vos access et votre salon. Vous ne pouvez \2PAS\2 revenir en arrire ");
			csntc(nick, "Rponse : /%s %s oui/non", cs.nick, RealCmd("drop"));
			SetUWantDrop(nick->user);
		}
		else csntc(nick, "\2Mot de passe invalide !");
	}
	DelNRegister(nick);
	return;
}

static void PerformLogin(aNick *nick)
{
	anAccess *a;
	aJoin *j = NULL;
	int needop, needvoice;

	/*auto-autoop propos par BugMaster :)*/
	for(a=nick->user->accesshead;a;a=a->next)
	{
		if((j=getjoininfo(nick,a->c->chan))) a->lastseen = 1; /* et non pas time(NULL) car il est sur le salon */

		if(j && (AOp(a) || AVoice(a)) && !ASuspend(a) && a->level >= 50)
		{
			needop = 0;
			needvoice = 0;
			if(AOp(a) && !j->is_op && a->level >= 100 && !CNoOps(a->c)) j->is_op = needop = 1;
			if(AVoice(a) && !j->is_voice) j->is_voice = needvoice = 1;
			if(needop || needvoice) csmode(a->c, "+%s%s %s %s", needop ? "o" : "", needvoice ? "v" : "", needop ? nick->numeric : "", needvoice ? nick->numeric : "");
		}
		if(a->c->motd[0] != '\0')	csntc(nick, "\2 [Message du jour] - %s -\2 %s", a->c->chan, a->c->motd);
		if(!j && CAutoInvite(a->c) && ((a->c->flag & C_MINV) || (a->c->flag & C_MKEY))) putserv("%s %s %s :%s\n", cs.num, TOKEN_INVITE, nick->nick, a->c->chan);
	}
	return;
}

static void do_login(aNick *nick, anUser *user)
{
	time_t current = time(NULL);
	if(UOubli(user)) DelUOubli(user);
	if(UFirst(user)) DelUFirst(user);
	SetNRegister(nick);
	nick->user = user;
	nick->user->n = nick;
	nick->user->lastseend = current;

	cs_account(nick, nick->user->nick);

	csntc(nick, "Login \2russi\2 pour %s, vous avez dsormais accs  tous vos salons, mmos et au contrle de votre pseudo", nick->user);

	if(IsAnAdmin(nick->user))
	{
		csntc(nick, "\2Vous tes identifi en tant qu'Administrateur niveau %d", nick->user->level);
#ifdef USE_WELCOMESERV
		if(admin_motd[0]!='\0') csntc(nick, "Message du jour Admin :\2 %s", admin_motd);
#endif
	}
#ifdef USE_WELCOMESERV
	else if(user_motd[0]!='\0') csntc(nick, "Message du jour User :\2 %s", user_motd);
#endif
#ifdef HAVE_CRYPTHOST
	if((ConfFlag & CF_HOSTHIDING) && (ConfFlag & CF_XMODE) && UWantX(user) && !(nick->flag & N_CRYPT)) putserv("%s %s %s :+x\n", cs.num, TOKEN_SVSMODE, nick->numeric);
#endif

#ifdef USE_MEMOSERV
	show_notes(nick);
#endif

#ifdef HAVE_VOTE
	if(vote_actif && vote_nbprop && !user->vote)
	{
		show_vote(nick);
		csntc(nick, "Pour voter tapez \2\37/%s %s <n de la proposition>\2\37.", cs.nick, RealCmd("voter"));
	}
#endif

	PerformLogin(nick);

	write_anuser(user); /* **joli** oubli qui a cout le deluser a beaucoup.. */
	return;
}

void ns_login(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *user = NULL;
#ifdef HAVE_TRACK
	struct track *track;
#endif
	time_t current = time(NULL);

	if(!(user = getuserinfo(parv[1])))
	{
		csntc(nick, NOSUCHUSER, parv[1]);
		return;
	}

	if(nick->user)
	{
		csntc(nick, "Vous tes dj identifi sous l'UserName \2%s\2.", nick->user->nick);
		if(IsAnAdmin(user) && user->nick != nick->user->nick)
		{
			cswall("Failed Login sur \2%s\2 par \2%s\2 (\2Admin %d\2)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s@%s\n", user->nick, user->level, user->mail, nick->nick, nick->user->nick);
		}
		return;
	}

	if(user->n)
	{
		csntc(nick, "Quelqu'un est dj identifi sur cet username");
		if(IsAnAdmin(user))
		{
			cswall("Failed Login sur \2%s\2 par \2%s\2 (\2Admin %d\2)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}
		return;
	}

	if(IsSuspend(user))
	{
		csntc(nick, "Votre Username est suspendu (depuis %s), soit par scurit, soit par les Admins, consultez votre e-mail pour connaitre votre nouveau pass", duration(current - user->suspend->debut));
		if(IsAnAdmin(user))
		{
			cswall("Failed Login sur \2%s\2 par \2%s\2 (\2Admin %d\2)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}
		return;
	}

	if(!checkpass(parv[2], user))
	{
		csntc(nick, "\2Mot de passe incorrect !\2");
		csntc(nick, "Si vous ne vous en rappelez plus, utilisez : \2/%s %s %s <mail>", cs.nick, RealCmd("oubli"), user->nick);
		if(IsAnAdmin(user))
		{
			cswall("Failed Login sur \2%s\2 par \2%s\2 (\2Admin %d\2)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}
		return;
	}

#ifdef HAVE_TRACK
	if((track=istrack(user))) csntc(track->tracker, "[\2Track\2] %s de %s (%s!%s@%s)", !strcasecmp(parv[0], "recover") ? "RECOVER" : "LOGIN", user->nick, nick->nick, nick->ident, nick->host);
#endif

#ifdef USE_NICKSERV
	del_killinfo(nick->nick, nick->numeric); /* arret du kill, vu ke c son nick !*/
#endif

	do_login(nick, user);

	return;
}

#ifdef USE_NICKSERV
void recover(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *user;
	time_t current = time(NULL);
	aNick *who, *w;
	char buff[NICKLEN + 1];

	if(!(user = getuserinfo(parv[1])))
	{
		csntc(nick, NOSUCHUSER, parv[1]);
		return;
	}
	if(nick->user)
	{
		if(nick->user == user) csntc(nick, "Vous tes dj logu sous cet username.");
		else
		{
			csntc(nick, "Vous tes dj identifi sous l'username \2%s\2, et vous ne pouvez avoir plus d'un username.", nick->user->nick);
			if(IsAnAdmin(user) && user != nick->user)
				putlog(LOG_FAUTH, "RECOVER %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}

		return;
	}

	if(IsSuspend(user))
	{
		csntc(nick, "Votre Username est suspendu (depuis %s), soit par scurit, soit par les Admins, consultez votre e-mail pour connaitre votre nouveau pass", duration(current - user->suspend->debut));
		if(IsAnAdmin(user))
		{
			cswall("Failed Login sur \2%s\2 par \2%s\2 (\2Admin %d\2)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}
		return;
	}

	if (!checkpass(parv[2], user))
	{
		csntc(nick, "\2Mot de passe incorrect !\2");
		csntc(nick, "Si vous ne vous en rappelez plus, utilisez : \2/%s %s %s <mail>\2", cs.nick, RealCmd("oubli"), user->nick);
		if(user->level > 1)
			putlog(LOG_FAUTH, "RECOVER %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		return;
	}
	who = nickhead;
	while(who)
	{
		w = who->next;
		if(strcasecmp(nick->nick, who->nick) && !strcasecmp(who->nick, user->nick))
		/* on a trouv un vilain avec le pseudo */
		{
			if(who->user && !strcasecmp(who->user->nick, user->nick)) /* Le vilain est loggu sur le compte a recover */
			{
				if(!UKill(user)) cs_account(who, NULL);
				csntc(who, "%s a utilis recover: \2vous n'tes plus identifi", nick->nick);
				who->user->n = NULL;
				who->user = NULL;
			}
			if(!UKill(user)) /* on svsnick */
			{
				snprintf(buff, NICKLEN, "%s%02d", CHNICKRAND, rand());
				putserv("%s " TOKEN_SVSNICK " %s :%s\n", bot.servnum, who->numeric, buff);
			}
			else /* ou bien on kill */
			{
				putserv("%s " TOKEN_KILL " %s :%s (Pseudo enregistr)\n", cs.num, who->numeric, cs.nick);
				del_nickinfo(who);
			}
			break; /* on termine la boucle, pas possible d'avoir 2 vilains avec le meme pseudo */
		}
		who = w;
	}
	if(!strcasecmp(user->nick, nick->nick) && UProtect(user)) del_killinfo(nick->nick, nick->numeric);

	if(user->n)
	{
		cs_account(user->n, NULL);
		csntc(user->n, "%s a utilis recover: \2vous n'tes plus identifi", nick->nick);
		user->n->user = NULL;
		user->n = NULL;
	}
	do_login(nick, user);

	return;
}
#endif

void myaccess(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char chans[512] = {0}, b[120], chansw[512] = {0};
	int access = 0, chan = 0, i = 0, size = 0, first = 0, sizew = 0, firstw = 0;
	anAccess *a;

	if(!nick->user) return;

	if(parc)
	{
		const char *cmd = parv[1];
		if(!strcasecmp(cmd, "accept"))
		{
			if(parc < 2)
			{
				csntc(nick, "Syntaxe: ACCEPT <#salon>");
				return;
			}

			if(!(nick->user->flag & U_POKACCESS))
			{
				csntc(nick, "Vous ne pouvez utiliser cette commande ! Vous %s toutes les propositions d'accs !", (nick->user->flag & U_PACCEPT) ? "acceptez" : "refusez");
				return;
			}
			for(a = nick->user->accesshead;a && strcasecmp(a->chan, parv[2]);a = a->next);

			if(!a || !(a->flag & A_WAITACCESS))
			{
				csntc(nick, "Vous n'avez aucune proposition d'access sur %s", parv[2]);
				return;
			}

			csntc(nick, "Vous avez maintenant un access sur %s", a->chan);
			a->flag &= ~A_WAITACCESS;
			write_anuser(nick->user);
			return;
		}
		if(!strcasecmp(cmd, "refuse"))
		{
			if(parc < 2)
			{
				csntc(nick, "Syntaxe: REFUSE <#salon>");
				return;
			}

			if(!(nick->user->flag & U_POKACCESS))
			{
				csntc(nick, "Vous ne pouvez utiliser cette commande ! Vous %s toutes les propositions d'accs !", (nick->user->flag & U_PACCEPT) ? "acceptez" : "refusez");
				return;
			}
			for(a = nick->user->accesshead;a && strcasecmp(a->chan, parv[2]);a = a->next);

			if(!a || !(a->flag & A_WAITACCESS))
			{
				csntc(nick, "Vous n'avez aucune proposition d'access sur %s", parv[2]);
				return;
			}

			csntc(nick, "La proposition d'accs pour %s a bien t refuse.", a->chan);
			del_access(nick->user, getchaninfo(a->chan));
			write_anuser(nick->user);
			return;
		}
		if(!strcasecmp(cmd, "drop"))
		{
			int niveau;

			if(parc < 2)
			{
				csntc(nick, "Syntaxe: DROP <#salon>");
				return;
			}

			if(!(niveau = ChanLevelbyUserI(nick->user, parv[2])))
			{
				csntc(nick, "Vous n'avez pas d'accs sur %s", parv[2]);
				return;
			}

			if(niveau == 500)
			{
				csntc(nick, "Vous ne pouvez pas supprimer un access de niveau 500 ! Utilisez UNREG pour supprimer le salon.");
				return;
			}

			del_access(nick->user, getchaninfo(parv[2]));
			write_anuser(nick->user);
			csntc(nick, "Vous avez bien supprim votre access de %s", parv[2]);
			return;
		}
	}

	access = getoption("-access",parv,parc,1,-1);
	if(!access)
	{
		csntc(nick, "Info sur l'Username \2%s", nick->user->nick);
		csntc(nick, " Mail enregistr: %s", nick->user->mail);
		if(IsAnAdmin(nick->user)) csntc(nick, "\2Accs Administrateur\2 (\002%d\2)", nick->user->level);

		for(a = nick->user->accesshead;a;a=a->next)
		{
			snprintf(b, 120, "%s (%d) ", a->chan, a->level);
			if((a->flag & A_WAITACCESS))
			{
				sizew += strlen(b);
				if(sizew >= 450) /* le dernier fait depasser le buffer */
				{
					strcat(chansw, " ...\0");
					csntc(nick, "%s%s", !firstw ? " Vous avez des propositions sur: " : "", chansw);
					strcpy(chansw, b); /* ajoute le suivant pour la prochaine*/
					firstw = 1;
					sizew = strlen(b);
				}
				else strcat(chansw, b);
			}
			else
			{
				size += strlen(b);
				if(size >= 450) /* le dernier fait depasser le buffer */
				{
					strcat(chans, " ...\0");
					csntc(nick, "%s%s", !first ? " Vous avez accs : " : "", chans);
					strcpy(chans, b); /* ajoute le suivant pour la prochaine*/
					first = 1;
					size = strlen(b);
				}
				else strcat(chans, b);
			}
		}

		strcat(chans, "\0");
		strcat(chansw, "\0");
		if(chans[0] != '\0') csntc(nick, "%s%s", !first ? " Vous avez accs : " : "", chans);
		else if(!first) csntc(nick, " Vous n'avez aucun accs.");
		if(chansw[0] != '\0') csntc(nick, "%s%s", !firstw ? " Vous avez des propositions sur: " : "", chansw);
		else if(!firstw) csntc(nick, " Vous n'avez aucune proposition d'access.");

#ifdef HAVE_VOTE
		if(vote_actif)
		{
			if(nick->user->vote) csntc(nick, " Vous avez vot pour: \2%s", vote[(nick->user->vote-1)].prop);
			else csntc(nick, " Vous n'avez pas encore vot");
		}
#endif
		csntc(nick, " Options: %s", GetUserOptions(nick->user));
		csntc(nick, " Last Login depuis %s", nick->user->lastlogin ? nick->user->lastlogin : "<Non Disponible>");
		return;
	}
	chan=getoption("-chan",parv,parc,1,0);
	for(a=nick->user->accesshead;a;a=a->next)
	{
		if((chan && match(parv[chan], a->chan)) || (a->flag & A_WAITACCESS)) continue;
		csntc(nick, "%s", a->chan);
		show_accessn(a, nick->user, nick);
		csntc(nick, "-");
		i++;
	}
	csntc(nick, "Un Total de %d entre%s trouve%s", i, i > 1 ? "s" : "", i > 1 ? "s": "");
	return;
}

void deauth(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
   if(!nick->user)
   {
      csntc(nick, "Vous n'tes pas logu");
	  return;
   }
   csntc(nick, "Vous venez de vous dlogguer du compte \2%s\2", nick->user->nick);
   cs_account(nick, NULL);
   nick->user->n = 0;
   nick->user = NULL;
   return;
}

void user_set(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	const char *arg = parv[1];

	if(!strcasecmp(arg,"mail"))
	{
		anUser *users;
		if(parc < 2)
		{
			csntc(nick, "Syntaxe: %s MAIL <mail>", RealCmd("set"));
			return;
		}
		if(strlen(parv[2]) > 99)
		{
			csntc(nick, "Le mail est limit  99 charactres.");
			return;
		}
		if(!IsValidMail(parv[2]))
		{
			csntc(nick, "Veuillez entrer un email correct.");
			return;
		}
		if(!strcasecmp(nick->user->mail, parv[2]))
		{
			csntc(nick, "%s est dj votre mail enregistr.", parv[2]);
			return;
		}

		for(users=userhead;users && strcasecmp(users->mail, parv[2]);users = users->next);
		if(users)
		{
			csntc(nick, "Ce mail est dj utilis.");
			return;
		}

		strcpy(nick->user->mail, parv[2]);
		nick->user->mail[99] = 0;
		csntc(nick, "Votre mail a t chang en \002%s", nick->user->mail);
	}
	else if(!strcasecmp(arg, "virtualhost"))
	{
		if(!(ConfFlag & CF_XMODE))
		{
			csntc(nick, "La commande VIRTUALHOST est desactive");
			return;
		}
		if(parc < 2) nick->user->flag = ToggleFlag(nick->user->flag, U_WANTX);
		else if(!strcasecmp(parv[2], "ON")) SetUWantX(nick->user);
		else if(!strcasecmp(parv[2], "OFF")) DelUWantX(nick->user);
		else
		{
			csntc(nick, "La valeur doit tre ON ou OFF");
			return;
		}

		if(UWantX(nick->user)) csntc(nick, "L'option VIRTUALHOST est ACTIVE: lors de votre identification, votre host sera automatiquement change en %s.%s", nick->user->nick, HIDDEN_HOST);
		else csntc(nick, "L'option VIRTUALHOST est DESACTIVE.");
	}
#ifdef USE_NICKSERV
	else if(!strcasecmp(arg, "kill"))
	{
		if(parc < 2) nick->user->flag = ToggleFlag(nick->user->flag, U_KILL);
		else if(!strcasecmp(parv[2], "ON")) SetUKill(nick->user);
		else if(!strcasecmp(parv[2], "OFF")) DelUKill(nick->user);
		else
		{
			csntc(nick, "La valeur doit tre ON ou OFF");
			return;
		}

		if(UKill(nick->user)) csntc(nick, "Si PROTECT est ON, lorsqu'un user prendra comme pseudo votre username, il se fera kill au bout de %d secondes", kill_interval);
		else csntc(nick, "Si PROTECT est ON, lorsqu'un user prendra comme pseudo votre username, il se fera changer son pseudo au bout de %d secondes", kill_interval);
	}
	else if(!strcasecmp(arg, "protect"))
	{
		if(parc < 2) nick->user->flag = ToggleFlag(nick->user->flag, U_PROTECT);
		else if(!strcasecmp(parv[2], "ON")) SetUProtect(nick->user);
		else if(!strcasecmp(parv[2], "OFF")) DelUProtect(nick->user);
		else
		{
			csntc(nick, "La valeur doit tre ON ou OFF");
			return;
		}

		if(UProtect(nick->user))
		{
			if(UKill(nick->user)) csntc(nick, "La protection est active. Lorsqu'un user prendra comme pseudo votre username, il se fera kill au bout de %d secondes", kill_interval);
			else csntc(nick, "La protection est active. Lorsqu'un user prendra comme pseudo votre username, il se fera chang de pseudo au bout de %d secondes", kill_interval);
		}
		else csntc(nick, "La protection est desactive", kill_interval);
	}
#endif
#ifdef USE_MEMOSERV
	else if(!strcasecmp(arg, "nomemo"))
	{
		if(parc < 2) nick->user->flag = ToggleFlag(nick->user->flag, U_NOMEMO);
		else if(!strcasecmp(parv[2], "ON")) SetUNoMemo(nick->user);
		else if(!strcasecmp(parv[2], "OFF")) DelUNoMemo(nick->user);
		else
		{
			csntc(nick, "La valeur doit tre ON ou OFF");
			return;
		}

		if(UNoMemo(nick->user))
			csntc(nick, "Le NOMEMO est actif: personne ne pourra vous envoyer de memos (except les admins)");
		else csntc(nick, "Le NOMEMO est inactif: tous le monde peut vous envoyer des memos");
	}
#endif
	else if(!strcasecmp(arg,"pass"))
	{
		char p[15];

		if(parc < 2)
		{
			csntc(nick, "Syntaxe: %s PASS <pass>", RealCmd("set"));
			return;
		}
		strncpy(p,parv[2],15);
		if(strlen(p) < 6)
		{
			csntc(nick, "Le pass doit faire entre 6 et 15 caractres.");
			return;
		}

		strcpy(nick->user->passwd, mkpass(p, "lala"));
		csntc(nick, "\2Votre mot de passe a bien t chang\2");
	}
	else if(!strcasecmp(arg, "username"))
	{
		anUser *u;

		if(parc < 2)
		{
			csntc(nick, "Syntaxe: %s USERNAME <nouvel username>", RealCmd("set"));
			return;
		}

		if(strlen(parv[2]) >= NICKLEN)
		{
			csntc(nick, "La longueur des UserNames est limite  %d.", NICKLEN);
			return;
		}

		if(!IsValidNick(parv[2]))
		{
			csntc(nick, "%s ne peut pas tre enregistr: contient des caractres illgaux", parv[2]);
			return;
		}
		if(IsBadNick(parv[2]))
		{
			csntc(nick, "%s ne peut pas tre enregistr: pseudo illgal.", parv[2]);
			return;
		}
		if((u=getuserinfo(parv[2])))
		{
			csntc(nick, "\2%s\2 est dj un UserName enregistr.", u->nick);
			return;
		}

		File_UserDel(nick->user->nick);
		cs_account(nick, parv[2]);
		strncpy(nick->user->nick, parv[2], NICKLEN);
		nick->user->nick[NICKLEN] = 0;
		csntc(nick, "Votre username a t chang en %s", parv[2]);
		write_userlist();
	}
	else if(!strcasecmp(arg, "access"))
	{
		int i;
		anAccess *a, *at;

		if(parc < 2)
		{
			csntc(nick, "Syntaxe: %s ACCESS <0/1/2>", RealCmd("set"));
			csntc(nick, "Syntaxe: 0 Refuse toute proposition d'accs");
			csntc(nick, "Syntaxe: 1 Requiert la confirmation/refus");
			csntc(nick, "Syntaxe: 2 Accepte toute proposition d'accs");
			return;
		}

		switch((i = atoi(parv[2])))
		{
			case 0:
			nick->user->flag &= ~(U_POKACCESS | U_PACCEPT);
			nick->user->flag |= U_PREJECT;
			csntc(nick, "Les propositions d'accs vous concernant seront systmatiquement refuses.");
			for(a = nick->user->accesshead;a;a = at)
			{
				at = a->next;
				if((a->flag & A_WAITACCESS)) del_access(nick->user, getchaninfo(a->chan));
			}
			csntc(nick, "Vos propositions en cours on t supprimes.");
			break;

			case 1:
			nick->user->flag &= ~(U_PACCEPT | U_PREJECT);
			nick->user->flag |= U_POKACCESS;
			csntc(nick, "Vous pourrez dsormais choisir via /%s %s ACCEPT/REFUSE <#salon> que faire d'un accs.", cs.nick, RealCmd("myaccess"));
			break;

			case 2:
			nick->user->flag &= ~(U_PREJECT | U_POKACCESS);
			nick->user->flag |= U_PACCEPT;

			csntc(nick, "Les propositions d'accs vous concernant seront systmatiquement acceptes.");
			for(a = nick->user->accesshead;a;a = a->next) a->flag &= ~A_WAITACCESS;
			csntc(nick, "Vos propositions en cours on t acceptes.");
			break;

			default:
			csntc(nick, "L'argument doit tre compris entre 0 et 2.");
			return;
		}

	}
	else
	{
		csntc(nick, "Option de SET inconnue.");
		return;
	}
	write_anuser(nick->user);
	return;
}
